
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Lettre extends Case { // grandes lettres pour inineraires
  char lettre;
  
  Lettre(char c) { lettre=c; }
  
  public void dessiner(int x,int y,int n) { 
    textSize(9*N); fill(color(0)); // noir
    textAlign(CENTER,CENTER); textMode(SHAPE);
    text(lettre,B+(x*9+4.5F)*N,B+(y*9+4.5F)*N-B/2);   
  }
}

class Nom extends Case { // noms des composants (aiguilles, zones et signaux)
  String nom;
  
  Nom(String n) { nom=n; }
  
  public void dessiner(int x,int y,int n) { 
    if (!infos) return;
    textSize(2.5F*N); fill(color(0)); // noir   perturbe les lettres !!!!!!!!!!!!
    textAlign(CENTER,CENTER); textMode(SHAPE);
    text(nom,B+(x*9+4.5F)*N,B+(y*9+4.5F)*N);   
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Suivi extends Case { // suivi des trains
  String nom;
  int coulTexte;
  
  Suivi() { nom="  "; }
  
  public void dessiner(int x,int y,int n) { //strokeWeight(2);
    if (nom=="  ") fill(COULEUR_FOND); else fill(COULEUR_GRISE); 
    ellipseMode(CORNER); ellipse(B+x*9*N,B+y*9*N,9*N,9*N); // le fond    
    textSize(4*N); fill(coulTexte); // perturbe les lettres !!!!!!!!!!!!
    textAlign(CENTER,CENTER); textMode(SHAPE);
    text(nom,B+(x*9+4.5F)*N,B+(y*9+4.5F)*N);   
  }

  void train(int t) {
    switch (t) {
      case 0: nom="  "; break;
      case 1: nom="T1"; coulTexte=COULEUR_BLEUE; break;
      case 2: nom="T2"; coulTexte=COULEUR_OR; break;
      default: println("?");
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

abstract class Bouton extends Case { // classe de base des boutons
  int no; // n° du bouton
  String nom; // nom sur le bouton
  boolean cli=false; // pour clignotement
  int coulFond,coulTexte; // couleur du fond et du texte
  
  Bouton(int n,String nm,int cf,int ct) { no=n; nom=nm; coulFond=cf; coulTexte=ct; }
  
  public void dessiner(int x,int y,int n) { //stroke(5);
  //print("dessiner");
    textSize(4*N); //    perturbe les lettres !!!
    textAlign(CENTER,CENTER); textMode(SHAPE);
    fill(coulFond);  rect(B+x*9*N,B+y*9*N,9*N,9*N,3*N); // le fond
    fill(coulTexte); text(nom,B+(x*9+4.5F)*N,B+(y*9+4.5F)*N);  // le texte
  }
  
  //abstract void exec(); // ce qu'il y a faire lors de l'appui sur le bouton
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class BoutonItineraire extends Bouton {
  BoutonItineraire(int n,String nm) { super(n,nm,COULEUR_GRISE,COULEUR_NOIRE); }

  public void dessiner(int x,int y,int n) { int coul; // clignotement
    coul=coulFond; //print("{"+bscCli+" "+cli+"}"); 
    if (bscCli && cli) coulFond=COULEUR_GRISE; 
    super.dessiner(x,y,n); coulFond=coul; 
  } 
  
  void exec() { portWrite(no+'0'); }
  void couleur(int c,boolean b) { coulFond=c; cli=b; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class BoutonCommande extends Bouton {
  int tr; // on peux pas mettre de train (null) ordre des declarations !!!
  
  BoutonCommande(int n,String nm,int cf,int ct,int t) { super(n,nm,cf,ct); tr=t; }
  
  void exec() { Train train; //print("exec"); 
    if (tr==1) train=train1; else train=train2;
    if (no==1) train.inverserSens(); else train.marcheArret(); 
  }
  void couleur(int c) { coulFond=c; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class BoutonControle extends Bouton {
  BoutonControle(int n,String nm) { super(n,nm,COULEUR_JAUNE,COULEUR_NOIRE); } // #D3D3D3
  
  void exec() { 
    switch (no) {
      case 1: grille=!grille; break;
      case 2: infos=!infos; break;
      case 3: if (trains) { trains=false; 
                if (!infos) { tco.bz0.train(0); tco.bz1.train(0); } // pas suivi des trains
                portWrite('a'); portWrite('b'); portWrite('c'); portWrite('d'); portWrite('e'); portWrite('f'); // liberation des zones
              } else { trains=true;
                portWrite('X'); delay(100); // reinitialisation totale Locodrome
                train1=new Train(1,IMPAIR,tco.z0,2,0,tco.bs2,tco.bma2); // train bleu  
                train2=new Train(2,PAIR,  tco.z1,0,0,tco.bs1,tco.bma1); // fleche d'or 
                tco.a0.directer(); tco.a1.directer();
                if (!infos) { tco.bz0.train(1); tco.bz1.train(2); } // suivi des trains
                portWrite('A'); portWrite('B'); // occupatin des zones
              }
              break;
      case 4: points=!points; break;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////