

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Point {
  float x,y; float a=0;
  
  Point(float x,float y) { this.x=x; this.y=y; }
  Point(float x,float y,float a) { this.x=x; this.y=y; this.a=a; }

public String toString() { return " ("+x+','+y+") "; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

abstract class Forme { 
  PShape s;
  PMatrix matrix=new PMatrix2D();
  Point[] points=null;

  Forme() { // constructeur
    s=createShape(); 
  }

  void dessiner(int x,int y,int n,int c) { 
    s.setFill(c); 
    translate(B,B); // bordure
    scale(N); // zoom
    s.applyMatrix(matrix);
    shape(s,x,y); // decalage ligne colonne
    s.resetMatrix();
    resetMatrix();
  }
  
  void rotation() { matrix.apply(0,-1,9, 1,0,0);  }
  void symetrie() { matrix.apply(-1,0,9, 0,1,0); }
  
  int largeur() { return 1; }

  void points() {}
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Droit extends Forme { // pas de rotation ni de symetrie sur points!!!
  Droit() { // constructeur
    s.beginShape();
    s.vertex(0,3); s.vertex(9,3); s.vertex(9,6); s.vertex(0,6);
    s.endShape(CLOSE);
}
  
  void points() { float lg,pas; int nb,i;
    lg=9; // longeur de la forme
    nb=(int)((0.5F+lg/PAS)/2); // calcul du nombre de points (avec arrondi)
    pas=lg/nb; // calcul du pas reel 
    points=new Point[nb]; 
    for (i=0; i<nb; i++) {
      Point p=new Point(i*pas+pas/2,4.5F); 
      PVector v=new PVector(p.x,p.y); matrix.mult(v,v); // fait les rotations et symetries
      points[i]=new Point(v.x,v.y);
    }
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class DroitN extends Droit { // grand droit   pas de rotation ni de symetrie sur points!!!
  int n;
  DroitN(int n) { 
    this.n=n;
    s.beginShape();
    s.vertex(0,3); s.vertex(9*n,3); s.vertex(9*n,6); s.vertex(0,6);
    s.endShape(CLOSE);
  }

  int largeur() { return n; }

  void points() { float lg,pas; int nb,i;
    lg=9*n; // longeur de la forme
    nb=(int)((0.5F+lg/PAS)/2); // calcul du nombre de points (avec arrondi)
    pas=lg/nb; // calcul du pas reel
    points=new Point[nb]; 
    for (i=0; i<nb; i++) {
      Point p=new Point(i*pas+pas/2,4.5F); 
      PVector v=new PVector(p.x,p.y); matrix.mult(v,v); // fait les rotations et symetries
      points[i]=new Point(v.x,v.y);
    }
    //points[i]=new Point(i*pas+pas/2,4.5F); 
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Arc extends Forme { 
  Arc() { // constructeur
    s.beginShape();
    s.vertex(10,1); s.quadraticVertex(5,6, 0,6); s.vertex(0,3); s.quadraticVertex(4,3, 8,-1);
    s.endShape(CLOSE);
  }

  void points() { float lg,r,a,apas; int nb,i; // sens antihoraire
    r=11.25F; // rayon
    a=acos(6.75F/11.25F); // angle de l'arc (constante)
    lg=(2*PI*r)*(a/(PI*2)); // longueur de l'arc (circonference*(a/2pi))
    nb=(int)((0.5F+lg/PAS)/2); // calcul du nombre de points (avec arrondi)
    points=new Point[nb]; 
    apas=a/nb; // angle de pas
    
    points=new Point[nb]; 
    a=HALF_PI-apas/2;
    for (i=0; i<nb; i++) { 
      Point p=new Point(r*cos(a),r*sin(a)-6.75); a-=apas; 
      PVector v=new PVector(p.x,p.y); matrix.mult(v,v); // fait les rotations et symetries
      points[i]=new Point(v.x,v.y,a);
    } 
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class ArcN extends Forme { // grande courbe   0.551784F
  int n;
  float nm=0.551784F; // nombre magique    
  
  ArcN(int n) { // constructeur
    this.n=n;
    s.beginShape();
    s.vertex(0,3); 
    s.bezierVertex((9*(n-1)+6)*nm, 3,   9*(n-1)+6, (9*n)-(9*(n-1)+6)*nm,   9*(n-1)+6, 9*(n-1)+9); 
    s.vertex(9*(n-1)+3, 9*(n-1)+9); 
    s.bezierVertex(9*(n-1)+3, (9*n)-(9*(n-1)+3)*nm,   (9*(n-1)+3)*nm, 6,    0, 6);
    s.endShape(CLOSE);
  }

  void dessiner(int x,int y,int n,int c) { 
    super.dessiner(x,y,n,c);
    if (grille) { color(255); strokeWeight(1); point(B+(x+4.5F)*N,B+(y+4.5F)*N); } // point a l'origine de l'arc
  }

  void points() { float lg,r,a,apas; int nb,i; // sens horaire
    r=9*(n-1)+4.5F; // calcul du rayon
    lg=(2*PI*r)/4; // longeur de l'arc
    nb=(int)((0.5F+lg/PAS)/2); // calcul du nombre de points (avec arrondi)
    points=new Point[nb]; 
    apas=HALF_PI/nb; // angle de pas
    
    points=new Point[nb]; a=-HALF_PI+apas/2; //   _90° a 0°
    for (i=0; i<nb; i++) { 
      Point p=new Point(r*cos(a),r*sin(a)+27); a+=apas; 
      PVector v=new PVector(p.x,p.y); matrix.mult(v,v); // fait les rotations et symetries
      points[i]=new Point(v.x,v.y,a);
    } 
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Cible extends Forme { // cible pour les signaux
  Cible() { // constructeur
    s.beginShape();
    s.vertex(3.4F,3); s.vertex(3.4F,0.4f); s.vertex(6,0.4F); s.vertex(6,-1); s.vertex(9,-1); s.vertex(9,2); s.vertex(6,2); s.vertex(6,0.6F); s.vertex(3.6F,0.6F); s.vertex(3.6F,3); 
    s.endShape(CLOSE);
  }
}

class Feu extends Forme { // feu pour les signaux
  int c;
  Feu(int c) { this.c=c; // constructeur
    s.beginShape();
    s.vertex(7.5F,-0.5F); 
    s.quadraticVertex(8.5F,-0.5F, 8.5F,0.5F); s.quadraticVertex(8.5F,1.5F, 7.5F,1.5F); 
    s.quadraticVertex(6.4F,1.5F, 6.5F,0.5F);  s.quadraticVertex(6.5F,-0.5F, 7.5F,-0.5F);
    s.endShape(CLOSE);
  }
  
  void dessiner(int x,int y,int n,int c) { 
    super.dessiner(x,y,n,this.c);
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Retrait extends Forme { // retrait pour separation des zones
  void dessiner(int x,int y,int n,int c) { 
    super.dessiner(x,y,n,COULEUR_FOND); // couleur fond
  }
}

class RetraitGauche extends Retrait {
  RetraitGauche() { 
    s.beginShape();
    s.vertex(0,3);
    s.vertex(0+R,3);
    s.vertex(0+R,6);
    s.vertex(0,6);
    s.endShape(CLOSE);
  }
}

class RetraitDroit extends Retrait {
  RetraitDroit() { 
    s.beginShape();
    s.vertex(9,3);
    s.vertex(9,6);
    s.vertex(9-R,6);
    s.vertex(9-R,3);
    s.endShape(CLOSE);
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////