/*
   for (Enumeration<E> e = v.elements(); e.hasMoreElements();)
       System.out.println(e.nextElement());
*/
import java.util.*;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Enum<T> implements Enumeration { // classe generique   T=Pave ou T=Point
  T[] elements; // tableau de T
  int no; // position courante
  int nb; // nombre d'elements
  boolean sens; // sens de <T> paves ou points
  
  Enum(boolean s,T[] es,int n) { // constructeur
    elements=es; sens=s; nb=elements.length; if (sens) no=n-1; else no=n+1;
  } 
  
  Enum(boolean s,T[] es) { // constructeur
    elements=es; sens=s; nb=elements.length; if (sens) no=-1; else no=nb;
  } 
  
  public boolean hasMoreElements() { if (sens) return no<nb-1; return no>0; } // test si encore des elements
  public T nextElement() { if (sens) return elements[++no]; return elements[--no]; } // l'element courant
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Train {
  Zone zone; // la zone ou est le train
  Pave pave; int x,y; // le pave et ses coordonnees
  Enum<Point> enumPoints; // pour enumeration des points
  Enum<Pave> enumPaves; // pour enumeration des paves
  boolean sens; // sens du train  
  int no; // n° du train
  boolean vitesse=false;
  BoutonCommande bouton1,bouton2; // sens et M/A (pour coloration)
  PShape loco; 

  Point point;
  
  Train(int n,boolean s,Zone z,int nPave,int nPoint,BoutonCommande b1,BoutonCommande b2) { 
    sens=s; no=n; bouton1=b1; bouton2=b2;
    zone=z; pave=zone.paves()[nPave]; x=pave.col; y=pave.lin; 
    enumPaves=new Enum(sens,zone.paves(),nPave+(sens?+1:-1)); 
    point=pave.getPoints()[nPoint];
    enumPoints=new Enum(sens?pave.sens:!pave.sens,pave.getPoints(),nPoint); 
    portWrite(zone.no+'A'); // redondant ??? non c'est celui qui sert

    loco=createShape();
    loco.beginShape();
    loco.noStroke();
    loco.fill(no==1?COULEUR_BLEUE:COULEUR_OR); // couleur    
    loco.vertex(-2,-2); loco.vertex(+2,-2); loco.vertex(+3.5,0); loco.vertex(+2,+2); loco.vertex(-2,+2);
    loco.endShape(CLOSE);  
}
  
  //boolean sensImpair() { return true; }

  void marcheArret() { vitesse=!vitesse; }

  void inverserSens() { 
    if (vitesse) return;  // vitesse non nulle
    if (zone!=tco.z0 && zone!=tco.z1) return; // que dans z0 ou z1
    sens=!sens; enumPaves.sens=!enumPaves.sens; enumPoints.sens=!enumPoints.sens; 
    if (no==1) portWrite('s'); else portWrite('S'); // train bleu   fleche d'or
  }
  
  boolean devantSignalFerme() { int c; // couleur du feu
    if ( pave instanceof PaveSignal && enumPoints.no==0) { // dans pave signal
      c=((PaveSignal)pave).getFeu(); //println("feu  "+c);
      if (c==#FF0000 && pave.sens==sens) return true; // couleur rouge et bon sens
    }
    return false;
  }
  
  void avancer() { Zone copie; // copie de la zone
    if (!vitesse) { bouton2.couleur(COULEUR_ROUGE); return; } // vitesse nulle
    else bouton2.couleur(COULEUR_VERTE_FONCEE); 
    if (devantSignalFerme()) { vitesse=false; return; }// arret si signal ferme
 
    if (enumPoints.hasMoreElements()) { // encore des points
      point=enumPoints.nextElement(); return; 
    } // plus de points
    if (enumPaves.hasMoreElements()) { // encore des paves
      pave=enumPaves.nextElement(); x=pave.col; y=pave.lin;   // println(); println("nouveau pave "+pave.sens);
      enumPoints=new Enum(sens?pave.sens:!pave.sens,pave.getPoints()); avancer(); return; // recursif
    } // plus de paves
    copie=zone;
    zone=zone.suivante(sens); // passer a la zone suivant
    if (zone==tco.z0 || zone==tco.z1) bouton1.couleur(COULEUR_VERTE_FONCEE); else bouton1.couleur(COULEUR_ROUGE); // que dans z0 ou z1
    portWrite(zone.no+'A'); // occuper la zone courante
    // retard a la liberation ???
    portWrite(copie.no+'a'); // liberer la zone precedente
    enumPaves=new Enum(sens,zone.paves()); avancer(); return; 
  } 

  void dessiner(int c) { float sin,cos,angle=0; // c'est une forme de loco centree en 4.5 4.5
    //println(no+"-"+sens+" p."+pave.sens);
    if (!sens) loco.applyMatrix(-1,0,0, 0,-1,0); // suivant le sens du train (symetrie centrale)
    translate(B,B); // bordure
    scale(N); // zoom 
    if (point.a!=0) { // arcs
      if (pave.sym) angle=-PI-point.a; else angle=point.a; // traitement symetrie
      angle-=HALF_PI; // calcul angle de la tangente
      pave.rot%=4; angle+=pave.rot*HALF_PI; // traitement rotation (modulo 4)
      angle+=pave.angle; // correctif (pour arc)
    } else { // droits
      angle=pave.angle; // correctif
    }
    sin=sin(angle); cos=cos(angle); // calcul des coeficients de la matrice de rotation
    //if (point.a!=old) { print(degrees(point.a)+"°:"+degrees(pave.angle)+"°="+degrees(angle)+"°   "); old=point.a; }
    loco.applyMatrix(cos,-sin,0,sin,cos,0); // rotation de la loco
    shape(loco,x*9+point.x,y*9+point.y); // dessin de la loco
    loco.resetMatrix();
    resetMatrix(); 
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////